﻿using System;
using System.IO;
using System.IO.IsolatedStorage;
using System.Windows;
using ICSharpCode.SharpZipLib.Core;
using ICSharpCode.SharpZipLib.Zip;
using Microsoft.Phone.Controls;
using Windows.ApplicationModel;
using Windows.Storage;

namespace CompressDemo
{
    public partial class MainPage : PhoneApplicationPage
    {
        // Constructor
        public MainPage()
        {
            InitializeComponent();

         
        }

    
        private async void OnCopyFileClicked(object sender, RoutedEventArgs e)
        {
            StorageFile file = await Package.Current.InstalledLocation.GetFileAsync("data.txt");
            await file.CopyAsync(ApplicationData.Current.LocalFolder);
        }

        private void OnCompressFileClicked(object sender, RoutedEventArgs e)
        {
            using (IsolatedStorageFile storage = IsolatedStorageFile.GetUserStoreForApplication())
            {
                using (IsolatedStorageFileStream fileToCompress = storage.OpenFile("data.txt", FileMode.Open, FileAccess.Read))
                {
                    using (IsolatedStorageFileStream zipFile = storage.OpenFile("CompressedFile.zip", FileMode.Create, FileAccess.ReadWrite))
                    {

                        ZipOutputStream file = new ZipOutputStream(zipFile);
                        ZipEntry entry = new ZipEntry("data.txt");
                        
                        file.PutNextEntry(entry);
                        StreamUtils.Copy(fileToCompress, file, new byte[4096]);
                        file.CloseEntry();
                        file.Close();
                    }
                }
            }
        }

        private void OnUncompressFileClicked(object sender, RoutedEventArgs e)
        {
            using (IsolatedStorageFile storage = IsolatedStorageFile.GetUserStoreForApplication())
            {
                using (IsolatedStorageFileStream zipFile = storage.OpenFile("CompressedFile.zip", FileMode.Open, FileAccess.Read))
                {
                    ZipFile file = new ZipFile(zipFile);
                    foreach (ZipEntry entry in file)
                    {
                        if (entry.IsFile)
                        {
                            using (IsolatedStorageFileStream dataFile = storage.OpenFile(entry.Name, FileMode.Create, FileAccess.ReadWrite))
                            {
                                Stream inputStream = file.GetInputStream(entry);
                                StreamUtils.Copy(inputStream, dataFile, new byte[4096]);
                            }
                        }
                    }
                }
            }
        }
    }
}